package com.io.yaohun.worldbosshurt;

import com.io.yaohun.worldbosshurt.command.BossSpawnerCmd;
import com.io.yaohun.worldbosshurt.listener.*;
import com.io.yaohun.worldbosshurt.mangage.BossManage;
import com.io.yaohun.worldbosshurt.mangage.RewardManage;
import com.io.yaohun.worldbosshurt.util.BossStack;
import com.io.yaohun.worldbosshurt.util.BossUtil;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;

public class Main extends JavaPlugin {

    public static Main plugin;
    public static BossManage bossManage;
    public static RewardManage rewardManage;

    @Override
    public void onEnable() {
        plugin = this;
        reloadMobDataYml();
        getCommand("bossspawner").setExecutor(new BossSpawnerCmd());
        getServer().getPluginManager().registerEvents(new BossSpawnLogs(),this);
        getServer().getPluginManager().registerEvents(new BossArmor(),this);
        getServer().getPluginManager().registerEvents(new BossDamageByPlayer(),this);
        getServer().getPluginManager().registerEvents(new BossKillsDeath(),this);
        getServer().getPluginManager().registerEvents(new BossDeathEvent(),this);
        getServer().getPluginManager().registerEvents(new BossProveEvent(),this);
        Bukkit.getConsoleSender().sendMessage("§b[BossHurt] §f插件成功载入Server！");
        Bukkit.getConsoleSender().sendMessage("§b[BossHurt] §f妖魂QQ:1763917516");
    }

    public void reloadMobDataYml(){
        File Datafile = new File("plugins/WorldBossHurt", "MobData.yml");
        bossManage = new BossManage(YamlConfiguration.loadConfiguration(Datafile));
        rewardManage = new RewardManage(YamlConfiguration.loadConfiguration(Datafile));
    }

    @Override
    public boolean onCommand(CommandSender sender, Command cmd, String Command, String[] args) {
        if(Command.equalsIgnoreCase("bossreload") && sender.isOp()){
            if(args.length == 1 && args[0].equalsIgnoreCase("test")){
                BossUtil.settlementRankingRewards();
                return true;
            }
            reloadMobDataYml();
            DemonAPI.sendMessage(sender,"配置文件已重载.");
            return true;
        }
        if(Command.equalsIgnoreCase("bosspz")){ // /bosspz
            if(args.length >= 2 && args[0].equalsIgnoreCase("give") && sender.isOp()){
                String bossName = args[1];
                if(args.length == 2) {
                    Player player = (Player) sender;
                    ItemStack pingzheng = BossStack.BossSlashProof(bossName).clone();
                    DemonAPI.giveItem(player,pingzheng);
                    DemonAPI.sendMessage(player,"恭喜你获得了 "+pingzheng.getItemMeta().getDisplayName());
                }
                if(args.length == 3) {
                    String playName = args[2];
                    Player player = Bukkit.getPlayer(playName);
                    if (player == null) {
                        DemonAPI.sendMessage(sender, "目标玩家不在线无法发送凭证。");
                        return true;
                    }
                    ItemStack pingzheng = BossStack.BossSlashProof(bossName).clone();
                    DemonAPI.giveItem(player,pingzheng);
                    DemonAPI.sendMessage(player,"恭喜你获得了 "+pingzheng.getItemMeta().getDisplayName());
                }
                return true;
            }
            if(args.length == 2 && args[0].equalsIgnoreCase("tpall") && sender.isOp()){
                Player p = (Player) sender;
                for (Entity entity : p.getWorld().getEntities()){
                    if(entity.getCustomName() != null) {
                        String customName = entity.getCustomName().replaceAll("§[a-zA-Z0-9]", "");
                        if (customName.contains(args[1])) {
                            entity.teleport(p.getLocation());
                        }
                    }
                }
                sender.sendMessage("操作执行成功.#"+args[1]);
                return true;
            }
        }
        return false;
    }
}
