package com.io.yaohun.worldbosshurt.api;

import com.io.yaohun.worldbosshurt.Main;
import com.io.yaohun.worldbosshurt.mangage.BossManage;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public abstract class BossHurtAPI {

    // 判断这个怪是否是世界boss
    public static boolean isBossExist(String customName){
        BossManage bossManage = Main.bossManage;
        if(bossManage.isCustomNameContains(customName)){
            return true;
        }
        return false;
    }

    //获取本月猎杀排行榜排行榜
    public static void sendTimeMonthTopMessage(Player p){
        FileConfiguration yml = Main.plugin.getConfig();
        double totalAmount = 0;
        HashMap<String, Integer> map = new HashMap<>();
        for (String playName : yml.getConfigurationSection("MonthlyKillsTop").getKeys(false)) {
            int amount = yml.getInt("MonthlyKillsTop."+playName);
            map.put(playName, amount);
            totalAmount = totalAmount + amount;
        }
        List<Map.Entry<String, Integer>> list = new ArrayList<>(map.entrySet());
        list.sort((o1, o2) -> o2.getValue().compareTo(o1.getValue()));
        int count = Math.min(list.size(), 10);
        int rank = 1;
        p.sendMessage("§c§M    §6§m    §e§m    §a§m    §b§m    §C§L▍ §c§l猎§6§l杀§E§L统§A§l计§B§L表 §C§l▍§b§M    §a§M    §e§M    §6§m    §c§m    §r");
        p.sendMessage("§e本月世界级boss猎杀排名如下:");
        for (int i = 0; i < count; i++) {
            if (rank == 11) {
                break;
            }
            String top_Name = list.get(i).getKey();
            p.sendMessage("§e第" + rank + "名 - §c" + top_Name + " §e总计猎杀: §c" + list.get(i).getValue() + "只 §e猎杀占总比: §c" + new DecimalFormat("0.00").format(list.get(i).getValue() / totalAmount * 100) + "%");
            ++rank;
        }
        p.sendMessage("§c§M    §6§m    §e§m    §a§m    §b§m    §C§L▍ §c§l猎§6§l杀§E§L统§A§l计§B§L表 §C§l▍§b§M    §a§M    §e§M    §6§m    §c§m    §r");
    }

    public static List<Map.Entry<String, Integer>> getTimeMonthTopHashMap(){
        FileConfiguration yml = Main.plugin.getConfig();
        double totalAmount = 0;
        HashMap<String, Integer> map = new HashMap<>();
        for (String playName : yml.getConfigurationSection("MonthlyKillsTop").getKeys(false)) {
            int amount = yml.getInt("MonthlyKillsTop."+playName);
            map.put(playName, amount);
            totalAmount = totalAmount + amount;
        }
        List<Map.Entry<String, Integer>> list = new ArrayList<>(map.entrySet());
        list.sort((o1, o2) -> o2.getValue().compareTo(o1.getValue()));
        return list;
    }
}
