package com.io.yaohun.worldbosshurt.command;

import com.io.yaohun.worldbosshurt.Main;
import com.io.yaohun.worldbosshurt.data.BossData;
import com.io.yaohun.worldbosshurt.event.WorldBossSpawnEvent;
import com.io.yaohun.worldbosshurt.mangage.BossManage;
import com.io.yaohun.worldbosshurt.listener.BossDamageByPlayer;
import com.io.yaohun.worldbosshurt.util.BossSpawnUtil;
import com.io.yaohun.worldbosshurt.util.BossUtil;
import lk.vexview.api.VexViewAPI;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabCompleter;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Item;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;

import java.util.ArrayList;
import java.util.List;

public class BossSpawnerCmd implements CommandExecutor , TabCompleter {

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if(BossUtil.isTimeMonthly()){
            BossUtil.settlementRankingRewards();
        }
        if(args.length == 0 && sender.isOp()){
            sender.sendMessage("§r");
            sender.sendMessage("§e------- ======= §6世界BOSS §e======= -------");
            sender.sendMessage("§2/bossspawner §e[代号] §f- §2生成Boss");
            sender.sendMessage("§e------- ======= §6世界BOSS §e======= -------");
            sender.sendMessage("§r");
            return true;
        }
        if(args.length >= 1 && sender.isOp()){
            BossManage bossManage = Main.bossManage;
            if(bossManage.isBossSurvive()){
                Bukkit.getConsoleSender().sendMessage("[日志-世界Boss] 系统尝试多次执行召唤boss已被拦截.");
                return true;
            }
            BossDamageByPlayer.damageMap.clear(); // 清理之前的伤害数据缓存

            boolean antiSpawn = false;
            if(args.length == 1) {
                String stats_type = BossSpawnUtil.getTheCurrentServerPlayerStatus();
                if (stats_type.equalsIgnoreCase("NoPlayer")) {
                    Bukkit.broadcastMessage("§6[§4公告§6] §a世界BOSS召唤失败,在线器师人数过低无法挑战.");
                    antiSpawn = true;
                }
                if (stats_type.equalsIgnoreCase("NoLevel")) {
                    Bukkit.broadcastMessage("§6[§4公告§6] §a世界BOSS召唤失败,在线器师无一人达到90级封号斗魂.");
                    antiSpawn = true;
                }
            }
            if(!antiSpawn){
                String bossKey = args[0];
                BossData bossData = bossManage.getBossData(bossKey);
                if(bossData != null){
                    Location spawnLoc = bossData.getLocation();// 获取生成点坐标
                    // 获取坐标周围30格范围内是否存在生物，若存在则清除
                    List<String> stringList = new ArrayList<>();
                    for (Entity entity : spawnLoc.getWorld().getNearbyEntities(spawnLoc,30,25,30)){
                        if(!(entity instanceof Item)) {
                            if(!(entity instanceof Player)){
                                if(entity.getCustomName() != null) {
                                    stringList.add(entity.getCustomName());
                                    entity.remove();
                                }
                            }
                        }
                    }
                    if(stringList.size() >= 1){
                        Bukkit.getConsoleSender().sendMessage("[日志-世界Boss] 清理周边怪物: "+stringList);
                    }
                    bossManage.setBossSurvive(true);
                    String bossName = bossData.getBossName();// 获取boss的自定义名字
                    String broadcast = bossData.getBc().replace("%mobs%",bossName); // 获取bc公告信息
                    Bukkit.broadcastMessage(broadcast);
                    Bukkit.broadcastMessage(broadcast);
                    // 发送VexViewAPI的信息
                    for (Player allp : Bukkit.getOnlinePlayers()) {
                        if (allp.getLevel() >= 40) {
                            // 发送Vex信息
                            String bc_vv = bossData.getBc_vv().replace("%mobs%", bossName);
                            VexViewAPI.sendFlowView(allp, bc_vv, 16, true);
                        }
                    }
                    new BukkitRunnable() {
                        private int seconds = 0;
                        public void run() {
                            if(seconds == 2){
                                bossManage.setBossSurvive(false);
                            }
                            if(seconds >= 20){
                                Bukkit.dispatchCommand(Bukkit.getConsoleSender(), "mythicmobs mobs spawn " + bossKey + " 1 " + bossData.getLocString());
                                cancel();
                            }
                            seconds++;
                        }
                    }.runTaskTimer(Main.plugin,0, 20L);
                    WorldBossSpawnEvent event = new WorldBossSpawnEvent(bossName);
                    Bukkit.getPluginManager().callEvent(event);
                }
            }
        }
        return false;
    }

    @Override
    public List<String> onTabComplete(CommandSender sender, Command command, String label, String[] args) {
        List<String> completions = new ArrayList<>();
        if(args.length == 1){
            completions.addAll(Main.bossManage.getBossKeyList());
        }
        return completions;
    }
}
