package com.io.yaohun.worldbosshurt.data;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.configuration.file.FileConfiguration;

public class BossData {
    private String bossKey;
    private String bossName;
    private int bossArmor;
    private String killsReward;
    private String topReward;
    private String locString;
    private String bc;
    private String bc_vv;

    public BossData(String bossKey,FileConfiguration yml){
        String str = "BossData."+bossKey+".";
        this.bossKey = bossKey;
        this.bossName = yml.getString(str+"name").replace("&","§");
        this.bossArmor = yml.getInt(str+"boss_armor") * 10000;
        this.killsReward = null;
        if(yml.getString(str+"reward_kills") != null) {
            this.killsReward = yml.getString(str + "reward_kills");
        }
        this.topReward = null;
        if(yml.getString(str+"reward_top") != null){
            this.topReward = yml.getString(str+"reward_top");
        }
        this.locString = yml.getString(str+"loc");
        this.bc = yml.getString(str+"bc").replace("&","§");
        this.bc_vv = yml.getString(str+"bc_vv").replace("&","§");
    }

    public Location getLocation() {
        String[] sp = this.locString.split(",");
        String worldName = sp[0];
        World world = Bukkit.getWorld(worldName);
        int x = Integer.parseInt(sp[1]);
        int y = Integer.parseInt(sp[2]);
        int z = Integer.parseInt(sp[3]);
        return new Location(world,x,y,z);
    }

    public String getBossKey() {return bossKey;}

    public int getBossArmor() {
        return bossArmor;
    }

    public String getKillsReward() {
        return killsReward;
    }

    public String getTopReward() {
        return topReward;
    }

    public String getBossName() {return bossName;}

    public String getLocString() {
        return locString;
    }

    public String getBc() {return bc;}
    public String getBc_vv() {return bc_vv;}
}
