package com.io.yaohun.worldbosshurt.data;

import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.configuration.file.FileConfiguration;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;

public class RewardData {

    private String rewardKey;

    private List<String> killsList;

    private List<String> damageList;

    private HashMap<String,List<String>> topList;

    public RewardData(String rewardKey,FileConfiguration yml){
        this.rewardKey = rewardKey;
        String str = "RewardGroup."+rewardKey+".";
        this.killsList = new ArrayList<>();
        if(yml.getString(str+"kills") != null){
            List<String> stringList = yml.getStringList(str+"kills");
            for (String s : stringList){
                if(s.contains(";")){
                    this.killsList.add(s);
                }else {
                    this.killsList.add(s);
                    this.killsList.add(s);
                    this.killsList.add(s);
                }
            }
        }
        this.damageList = new ArrayList<>();
        if(yml.getString(str+"damage") != null){
            this.damageList = yml.getStringList(str+"damage");
        }
        HashMap<String,List<String>> hashMap = new HashMap<>();
        if(yml.getConfigurationSection(str+"top") != null) {
            for (String top : yml.getConfigurationSection(str + "top").getKeys(false)) {
                List<String> stringList = yml.getStringList(str + "top." + top);
                hashMap.put(top, stringList);
            }
        }
        this.topList = hashMap;
    }

    public String getRewardKey() {
        if(rewardKey != null) {
            return rewardKey;
        }
        return "无奖励";
    }

    // 获取最终击杀命令
    public List<String> getKillsCmdList(){
        int suijishu = (DemonAPI.getRandomInt(killsList.size(), 1) - 1);
        String cmdsp = killsList.get(suijishu);
        List<String> commands = Collections.singletonList(cmdsp);
        if(cmdsp.contains(";")) {
            commands = DemonAPI.StringConvertStringList(cmdsp, ";");
        }
        /*for (String s : commands){
            Bukkit.getConsoleSender().sendMessage("#Text = "+s);
        }*/
        return commands;
    }

    // 获取排名奖励
    public List<String> getTopCmdList(int top){
        String topKey = String.valueOf(top);
        if(this.topList.get(topKey) != null) {
            return this.topList.get(topKey);
        }
        return new ArrayList<>();
    }

    // 获取排名奖励数量
    public int getTopCmdSize(){
        return this.topList.size();
    }

    // 获取累积伤害奖励
    public List<String> getDamageCmdList(){
        return this.damageList;
    }
}
