package com.io.yaohun.worldbosshurt.listener;

import com.io.yaohun.worldbosshurt.Main;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.entity.Projectile;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageByEntityEvent;

import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.UUID;

public class BossDamageByPlayer implements Listener {

    public static HashMap<Player,Double> damageMap = new HashMap<>();

    private void addPlayerDamage(Player player,double damage){
        double newDamage = damage / 1000;
        if(damageMap.get(player) == null){
            damageMap.put(player,newDamage);
            return;
        }
        double addDamage = newDamage + damageMap.get(player);
        damageMap.put(player,addDamage);
    }

    @EventHandler(ignoreCancelled = true, priority = EventPriority.MONITOR)
    public void onEntityDamageByPlayer(EntityDamageByEntityEvent e) {
        if(e.getDamager() instanceof Player){
            Entity entity = e.getEntity();
            String customName = entity.getCustomName();
            if(customName != null && Main.bossManage.isCustomNameContains(customName)){
                Player p = (Player) e.getDamager();
                String worldName = p.getWorld().getName();
                if(!worldName.equalsIgnoreCase("teamDungee")) {
                    if(customName.contains("§t§e§a§m")){
                        e.getEntity().remove();
                        Bukkit.getConsoleSender().sendMessage("[世界boss-日志] 因 "+customName+" §r离开团队副本,此Boss已清理.");
                        return;
                    }
                    boolean isBossName = false;
                    for (String bossName : BossSpawnLogs.WhiteBossList){
                        if(customName.contains(bossName)){
                            isBossName = true;
                            break;
                        }
                    }
                    if(!isBossName){
                        e.getEntity().remove();
                        Bukkit.broadcastMessage("§6[§4公告§6] §a"+customName+"§a被卷入了异次元时空.");
                        return;
                    }
                    double damage = e.getDamage();
                    DemonAPI.sendTitle(p, 5, 20, 5, "", "§c§l造成伤害: §a§l+" + new DecimalFormat("0.00").format(damage));
                    addPlayerDamage(p,e.getDamage());
                }
            }
        }
    }

    @EventHandler(ignoreCancelled = true, priority = EventPriority.MONITOR)
    public void onEntityDamageByProjectile(EntityDamageByEntityEvent e) {
        if (e.getDamager() instanceof Projectile) {
            Projectile projectile = (Projectile) e.getDamager();
            if (projectile.getShooter() instanceof Player) {
                Entity entity = e.getEntity();
                String customName = entity.getCustomName();
                if (customName != null && Main.bossManage.isCustomNameContains(customName)) {
                    Player p = (Player) projectile.getShooter();
                    String worldName = p.getWorld().getName();
                    if (!worldName.equalsIgnoreCase("teamDungee")) {
                        if (customName.contains("§t§e§a§m")) {
                            e.getEntity().remove();
                            Bukkit.getConsoleSender().sendMessage("[世界boss-日志] 因 " + customName + " §r离开团队副本,此Boss已清理.");
                            return;
                        }
                        UUID Mob_uuid = e.getEntity().getUniqueId();
                        if (!BossSpawnLogs.WhiteBossList.contains(Mob_uuid)) {
                            e.getEntity().remove();
                            Bukkit.broadcastMessage("§6[§4公告§6] §a" + customName + "§a被卷入了异次元时空.");
                            return;
                        }
                        double damage = e.getDamage();
                        DemonAPI.sendTitle(p, 5, 20, 5, "", "§c§l造成伤害: §a§l+" + new DecimalFormat("0.00").format(damage));
                        addPlayerDamage(p, e.getDamage());
                    }
                }
            }
        }
    }
}
