package com.io.yaohun.worldbosshurt.mangage;

import com.io.yaohun.worldbosshurt.Main;
import com.io.yaohun.worldbosshurt.data.BossData;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.FileConfiguration;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class BossManage {

    private boolean bossSurvive;
    private final List<String> bossKeyList = new ArrayList<>(); // 获取boss名列表
    private final List<String> customNameList = new ArrayList<>(); // 获取boss名列表
    private final HashMap<String,BossData> bossDataMap = new HashMap<>();

    public BossManage(FileConfiguration yml) {
        this.bossSurvive = false;
        for (String bossKey : yml.getConfigurationSection("BossData").getKeys(false)){
            bossDataMap.put(bossKey,new BossData(bossKey,yml));
            String customName = yml.getString("BossData."+bossKey+".name");
            customNameList.add(customName);
            bossKeyList.add(bossKey);
        }
        Bukkit.getConsoleSender().sendMessage("§b[BossHurt] §f已导入Boss: §a" + customNameList.size() + "只");
    }

    public BossData getBossData(String bossKey) {
        if(bossDataMap.get(bossKey) == null){
            return null;
        }
        return bossDataMap.get(bossKey);
    }

    public BossData getNameToData(String customName) {
        for (String bossKey : bossDataMap.keySet()){
            BossData data = bossDataMap.get(bossKey);
            String bossName = data.getBossName();
            if(customName.contains(bossName)){
                return data;
            }
        }
        return null;
    }

    public boolean isBossSurvive() {
        return bossSurvive;
    }
    public void setBossSurvive(boolean butt){
        bossSurvive = butt;
    }

    public List<String> getBossKeyList() {
        return bossKeyList;
    }

    public boolean isCustomNameContains(String customName){
        for (String name : this.customNameList){
            if(customName.contains(name)){
                return true;
            }
        }
        return false;
    }


}
